#property copyright "Copyright  2013, ForexMT4Systems."
#property link      "http://www.forexmt4systems.com"

#property  indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  Blue
#property indicator_color2  Red
#property indicator_width1  4
#property indicator_width2  4
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern int    MaPeriod        = 15;
extern int    MaShift         = 1;
extern int    MaMode          = MODE_SMA;
extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsNotify    = false;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

//
//
//
//
//

double trend[];
double Up[];
double Dn[];

//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,Up);  SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Dn);  SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,trend);
return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars  = IndicatorCounted(); 
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
          int limit = MathMin(Bars - counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(int i = limit; i >= 0; i--)
   {
      trend[i] = trend[i+1];
      Up[i] = EMPTY_VALUE;
      Dn[i] = EMPTY_VALUE;
      if (Close[i]>iMA(NULL,0,MaPeriod,MaShift,MaMode,PRICE_HIGH,i+1)) trend[i] = 1;
      if (Close[i]<iMA(NULL,0,MaPeriod,MaShift,MaMode,PRICE_LOW, i+1)) trend[i] =-1;
      if (trend[i] == 1) Up[i] = 1;
      if (trend[i] ==-1) Dn[i] = 1;
      
      //
      //
      //
      //
      //
    }  
      if (alertsOn)
      {
         if (alertsOnCurrent)
              int whichBar = 0;
         else     whichBar = 1;
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert("Bullish");
         else  doAlert("Bearish");       
   }
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ForexMT4Systems_BBars ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," ForexMT4Systems_BBars "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}   